

        .data
point:  .word  table   @ puntero a la tabla de movimientos   
table:  .space 64      @ tabla de movimientos (para 4 discos)
        .equ   ORI,'A' @ nombre del poste origen
        .equ   DES,'C' @ nombre del poste destino
        .equ   AUX,'B' @ nombre del poste auxiliar

   .text

@ llamada inicial al subprograma:  hanoi(4, 'A', 'C', 'B')

main:
   mov   r0,#4     @ 4 discos
   mov   r1,#ORI   @ poste de origen es 'A'
   mov   r2,#DES   @ poste de destino es 'C'
   mov   r3,#AUX   @ poste auxiliar es 'B'
   bl    hanoi     @ llamamos al subprograma
   wfi

/* Subprograma hanoi. Parámetros:

   r0 -> n (número de discos)
   r1 -> poste origen  (char)
   r2 -> poste destino (char)
   r3 -> poste auxiliar (char)
*/
hanoi:
   push  {r0-r6,lr} @ algoritmo recursivo: todo el contexto
   cmp   r0,#1      @ a la pila
   bne   again      @ if (n<>1) seguimos con la recursividad

@ n == 1: mueve (1, de, a)

   lsl   r0,#8      @ en r0 tenemos el número de disco
   orr   r0,r1      @ montamos el poste origen sobre r0
   lsl   r0,#8      
   orr   r0,r2      @ y también el poste destino

   ldr   r4,=point  @ almacena el último movimiento
   ldr   r5,[r4]
   str   r0,[r5]
   add   r5,#4      @ actualizamos el puntero a la tabla
   str   r5,[r4]
   b     finh

@ n <> 1 : hanoi(n-1, de, aux, a); mueve(n, de, a);;
@          hanoi(n-1 ,aux ,a ,de)

again:
   sub   r0,#1      @ llamada recursiva      
   mov   r4,r3      @ hanoi(n-1, de, aux, a)
   mov   r3,r2
   mov   r2,r4
   bl    hanoi

   mov   r6,r0      @ mueve (n, de, a)
   add   r6,#1      @ recuperamos el valor de n
   lsl   r6,#8      @ y montamos sobre r6
   orr   r6,r1      @ n, poste origen y poste destino
   lsl   r6,#8
   orr   r6,r3

   ldr   r4,=point
   ldr   r5,[r4]
   str   r6,[r5]   @ almacena este movimiento
   add   r5,#4     @ actualizamos el puntero
   str   r5,[r4]

   mov   r4,r1     @ llamada recursiva
   mov   r1,r2     @ hanoi(n-1, aux, a, de)
   mov   r2,r3
   mov   r3,r4
   bl    hanoi

@ recuperamos el contexto de la pila

finh:   
   pop   {r0-r6,pc}
   .end