      .data

@  Secuencia de cartas obtenidas

mano:
      .byte 1, 2, 3, 4, 10, 5, 6, 11, 7, 0

@  Tabla de saltos

	.balign 4
jump_tab:
carta1: .word s_carta1
carta2: .word s_carta2
carta3: .word s_carta3
carta4: .word s_carta4
carta5: .word s_carta5
carta6: .word s_carta6
carta7: .word s_carta7

      .text
/*
  Programa de prueba. Partimos de una puntuación
  (en r1) de 10 y jugamos las cartas 1 oros, 
  2 copas, 3 espadas, 4 oros, sota de oros, 
  5 copas, 6 bastos, caballo de oros, 7 de oros
  en ese orden. La puntuación final en
  r1 es r1 = 35 = 0x23
*/
main: mov  r1,#10       @ inicializamos r1 a 10
      ldr  r4,=mano     @ r4: dir. lista de cartas
buc:  ldrb r0,[r4]      @ r0: valor de carta
      cmp  r0,#0        @ vemos si hemos terminado
      beq  done         
      bl   comp_score   @ jugamos la carta
      add  r4,r4,#1     @ apuntamos a la siguiente carta
      b  buc            @ repetimos

done: wfi
      
/*
  comp_score. Juega una carta. 
  Parámetros:
      - r0: valor de la carta en el byte menos significativo
      - r1: valor inicial de la puntuación
  Salida:
      - r1: nuevo valor de la puntuación.
*/
comp_score:
      cmp r0,#0         @ si no es una carta válida
      ble ocs           @ hemos terminado
      cmp r0,#7
      bgt ocs

/* tenemos un carta válida */

      sub r0,r0,#1      @ calculamos la entrada en la tabla
      lsl r0,r0,#2      @ de saltos para este carta:
      ldr r2,=jump_tab  @ dir seg. código a r2: 
      ldr r2,[r2,r0]    @ r2 = jump_tab + (ro - 1) * 4
      push {r2}         @ pasamos la dir. del código en r2
      pop {pc}          @ al pc
     
ocs:  mov pc, lr        @ terminamos. Volvemos al programa
                        @ principal
/* 
  Carta 1: r1 <- r1 * 5
*/ 
s_carta1:
      mov r2,r1
      lsl r1,r1,#2
      add r1,r1,r2
      b   ocs

/* 
  Carta 2: r1 <- r1 - 10
*/ 
s_carta2:
      sub r1,r1,#10
      b   ocs

/* 
  Carta 3: r1 <- r1 + 10
*/ 
s_carta3:
      add r1,r1,#10
      b   ocs

/* 
  Carta 4: r1 <- r1 / 2
*/ 
s_carta4:
      lsr r1,r1,#1
      b   ocs

/* 
  Carta 5: r1 <- r1 - 5
*/ 
s_carta5:
      sub r1,r1,#5
      b   ocs

/* 
  Carta 6: r1 <- r1 * 3
*/ 
s_carta6:
      mov r2,r1
      lsl r1,r1,#1
      add r1,r1,r2
      b   ocs

/* 
  Carta 7: r1 <- (r1 + 10) / 2
*/ 
s_carta7:
      add r1,r1,#10
      lsr r1,r1,#1
      b   ocs
      .end