
        .data
m_leds: .space 8       @ memoria utilizada por la matriz

        .text

@
@ Programa principal
@
.equ  activar,1
.equ  desactivar,0

main: ldr r0,=m_leds   @ activamos la X
      mov r1,#activar
      bl  act_lx

      ldr r0,=m_leds   @ desactivamos la X
      mov r1,#desactivar
      bl  act_lx

      wfi

/*
 act_lx: subrutina que activa una X (las dos diagonales) d
 e una matriz de bits 8 x 8.

Parámetros:
    r0: dirección de comienzo de la matriz
    r1: 1 para indicar activar y 0 para desactivar
*/
act_lx:
    push {r4,r5,lr} @ preservamos la dir. de retorno y
                    @ registros por encima de r3
    push {r0}       @ apilamos dir. matriz y acción
    push {r1}       @ común para todas las llamadas a
                    @ setbit
    mov  r4,#7      @ contador de iteraciones y offsets
    mov  r5,#0      @ de las diagonales
otro:
    mov  r0,#8      @ activamos el bit i-ésimo
    mov  r1,#8      @ de la diagonal principal
    mov  r2,r5
    mov  r3,r5
    bl   setbit

    mov  r0,#8      @ activamos el bit i-ésimo
    mov  r1,#8      @ de la diagonal secundaria
    mov  r2,r5
    mov  r3,r4
    bl   setbit

    cmp  r4,#0      @ comprobamos si hemos terminado
    beq  fin

    add  r5,r5,#1   @ preparamos los dos siguientes bits
    sub  r4,r4,#1   @ de la siguiente fila
    b    otro

fin:
    add sp,#8       @ balanceamos la pila
    pop {r4,r5,pc}  @ recuperamos los registros y volvemos
    .end
